<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <style>
        form {
            width: 200px;
            height: auto;
        }
        #btn{
            margin-top: 5px;
        }
    </style>
</head>
<body>
    <div id="app">
        <form @submit.prevent="submitForm()">
            <p v-if="errors.length">
                <b>Tolong Ikuti Intruksi</b>
                <ul>
                    <li v-for="error in errors">{{ error }}</li>
                </ul>
            </p>
            <label>name : </label>
            <input type="text" :disabled="buttonStatus == 'upload'" name="name" ref="name" v-model="name" required>
            <label>address : </label>
            <input type="text" :disabled="buttonStatus == 'upload'" name="address" v-model="address" required>
            <label>no_hp</label>
            <input type="text" :disabled="buttonStatus == 'upload'" name="no_hp" v-model="no_hp" required>
            <div v-if="buttonStatus == 'submit'">
                <input type="submit" value="SUBMIT">
            </div>
            <div v-else-if="buttonStatus == 'update'">
                <input type="button" value="UPDATE" @click="updateMember(idEditMember)" id="btn">
                <input type="button" value="CANCEL" @click="clearForm" style="margin-top: 5px;">
            </div>
            <div v-else-if="buttonStatus == 'upload'">
                <input type="file" name="photo" ref="photo">
                <input type="button" value="UPLOAD" @click="submitPhoto(idUploadMember)" style="margin-top: 5px; margin-bottom: 5px;">
                <input type="button" value="CANCEL" @click="clearForm" style="margin-top: 5px;">
            </div>
            
        </form>
        <br><br>
        <template id="MembersComponent">
            <table border="1">
                <tr v-for="member of members">
                    <td>
                        <img width=100px v-bind:src="member.photo_profile ? photoDomain + member.photo_profile : 'https://dummyimage.com/600x400/000/fff'" alt="">
                    </td>
                    <td>
                        <b>Name : </b> {{member.name}} <br>
                        <b>Address : </b> {{member.address}} <br>
                        <b>No_hp : </b> {{member.no_hp}} <br>
                    </td>
                    <td>
                        <button @click="editMember(member)">Edit</button>
                        <button @click="removeMember(member.id)">Hapus</button>
                        <button @click="uploadPhoto(member)">Upload Foto</button>
                    </td>
                </tr>
            </table>
        </template>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        Vue.component('meber-component' , {
            template : '#MembersComponent'
        })

        var vm = new Vue ({
            el: "#app",
            data: {
                name : '',
                address : '',
                no_hp: '',
                errors : [],
                members : [],
                photoDomain : 'http://demo-api-vue.sanbercloud.com',
                buttonStatus : 'submit',
                idEditMember : null,
                idUploadMember : null           
            },

            methods: {
                clearForm : function() {
                    this.name = '',
                    this.address = '',
                    this.no_hp = ''
                },

                submitForm : function(){
                  let formData = new FormData()
                  formData.append('name', this.name)
                  formData.append('address', this.address)
                  formData.append('no_hp', this.no_hp)

                  const config ={
                      method : 'post',
                      url : 'http://demo-api-vue.sanbercloud.com/api/member',
                      data : formData
                  }

                  axios(config)
                  .then((response) => {
                    this.clearForm()
                    this.getMembers()
                    alert(response.data.message)
                  })
                  .catch((error) => {
                    
                  })
                },

                getMembers : function(){
                    const config = {
                        method : "get",
                        url : "http://demo-api-vue.sanbercloud.com/api/member"
                    }

                    axios(config)
                        .then((response) => {
                            this.members = response.data.members
                            // console.log(response.data.members)
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                },

                removeMember : function(id) {
                    const config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params : { _method : "DELETE"}
                    }

                    axios(config)
                    .then( (response) => {
                        this.getMembers()
                        alert(response.data.message)
                    })
                    .catch( (error) => {
                        console.log(error)
                    })
                },

                editMember : function(member){
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'update'
                    this.idEditMember = member.id
                },

                clearForm : function() {
                    this.name = ''
                    this.address = ''
                    this.no_hp = ''
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                    this.idUploadMember = null
                },

                updateMember : function(id){
                    let formData = new FormData()
                    formData.append('name', this.name)
                    formData.append('address', this.address)
                    formData.append('no_hp', this.no_hp)
                   
                    let config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params : {_method : 'PUT'},
                        data : formData
                    }

                    axios(config)
                    .then( (response) => {
                        this.clearForm()
                        this.getMembers()
                        alert(response.data.message)
                    })
                    .catch( (error) => {
                        console.log(error)
                    })
                },

                uploadPhoto : function(member){
                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'upload'
                    this.idUploadMember = member.id
                }, 

                submitPhoto : function(id){
                    let file = this.$refs.photo.files[0]

                    let formData = new FormData()
                    formData.append('photo_profile', file)

                    let config = {
                        method : "post",
                        url : `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                        data : formData
                    }

                    axios(config)
                    .then( (response) => {
                        this.clearForm()
                        this.getMembers()
                        alert(response.data.message)
                    }) 
                    .catch( (error) => {
                        console.log(error)
                    })
                }
            },
            
            created(){
                this.getMembers()
            }
        })
    </script>
</body>
</html>
